/*
   This program "produces" sequential numbers to stdout.
   The rate of production is set by a command-line argument.

   Pipe the output from this program into the input of consumer.

   Make the producer twice as fast as the consumer, so
   the producer will keep the buffer between them full.
   > producer 100 | consumer 200
   > producer 10  | consumer 20
   > producer 1   | consumer 2
*/
#include <stdio.h>
#include <limits.h>
#include <windows.h>   // Winddows Sleep()
//#include <unistd.h>  // Posix sleep()

int main(int argc, char **argv)
{
   int count = INT_MAX;
   int counter = 0;
   int milliSeconds = 500;
   if (argc > 1)
   {
      milliSeconds = atoi(argv[1]);
   }
   if (argc > 2)
   {
      count = atoi(argv[2]);
   }
   while(count >= 0)
   {
      fprintf(stdout, "%d ",  counter);
      fprintf(stderr, "%d\n", counter);
      //fflush(stdout);
      ++counter;
      --count;
      Sleep(milliSeconds);
   }
   return 0;
}
